package net.sourceforge.openutils.mgnlcontrols.dialog;

import info.magnolia.cms.beans.runtime.Document;
import info.magnolia.cms.beans.runtime.MultipartForm;
import info.magnolia.cms.core.Content;
import info.magnolia.cms.core.HierarchyManager;
import info.magnolia.cms.core.ItemType;
import info.magnolia.cms.core.NodeData;
import info.magnolia.cms.core.Path;
import info.magnolia.cms.gui.fckeditor.FCKEditorTmpFiles;
import info.magnolia.cms.security.AccessDeniedException;
import info.magnolia.cms.util.ContentUtil;
import info.magnolia.cms.util.NodeDataUtil;
import info.magnolia.context.MgnlContext;
import info.magnolia.module.admininterface.FieldSaveHandler;
import info.magnolia.module.admininterface.SaveHandlerImpl;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.jcr.RepositoryException;

import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Needed by file upload. Setup: assign this class name as a "saveHandler"
 * property of the grid field's configuration node.
 * 
 * @author dschivo
 * 
 */
public class DialogGridSaveHandler implements FieldSaveHandler
{

    public static Logger log = LoggerFactory.getLogger(DialogGridSaveHandler.class);

    @SuppressWarnings("unchecked")
    public void save(Content parentNode, Content configNode, String name, MultipartForm form, int type, int valueType,
            int isRichEditValue, int encoding) throws RepositoryException, AccessDeniedException
    {
        HierarchyManager hm = parentNode.getHierarchyManager();
        Content filesNode = ContentUtil.getOrCreateContent(parentNode, name + "_files", ItemType.CONTENTNODE);
        String value = form.getParameter(name);
        String ctx = MgnlContext.getContextPath();
        String tmpPath = "/tmp/fckeditor/";
        List usedFiles = new ArrayList();
        StringBuffer sbValue = new StringBuffer(value.length());
        StringBuffer sbLine = new StringBuffer();
        for (String line : StringUtils.splitPreserveAllTokens(value, '\n'))
        {
            for (String token : StringUtils.splitPreserveAllTokens(line, '\t'))
            {
                if (token.startsWith(ctx))
                {
                    String link = StringUtils.substringAfter(token, ctx);
                    if (StringUtils.startsWith(link, tmpPath))
                    {
                        String uuid = StringUtils.substringBetween(link, tmpPath, "/");
                        Document doc = FCKEditorTmpFiles.getDocument(uuid);
                        String fileNodeName = Path.getUniqueLabel(hm, filesNode.getHandle(), "file");
                        SaveHandlerImpl.saveDocument(filesNode, doc, fileNodeName, "", "");
                        link = filesNode.getHandle() + "/" + fileNodeName + "/" + doc.getFileNameWithExtension();
                        token = link;
                        doc.delete();
                        try
                        {
                            FileUtils.deleteDirectory(new java.io.File(Path.getTempDirectory() + "/fckeditor/" + uuid));
                        }
                        catch (IOException e)
                        {
                            log.error("can't delete tmp file [" + Path.getTempDirectory() + "/fckeditor/" + uuid + "]");
                        }
                    }
                }
                if (token.startsWith(filesNode.getHandle()))
                {
                    String fileNodeName = StringUtils.removeStart(token, filesNode.getHandle() + "/");
                    fileNodeName = StringUtils.substringBefore(fileNodeName, "/");
                    usedFiles.add(fileNodeName);
                }
                if (sbLine.length() > 0)
                {
                    sbLine.append('\t');
                }
                sbLine.append(token);
            }
            if (sbValue.length() > 0)
            {
                sbValue.append('\n');
            }
            sbValue.append(sbLine);
            sbLine.setLength(0);
        }
        for (Iterator iter = filesNode.getNodeDataCollection().iterator(); iter.hasNext();)
        {
            NodeData fileNodeData = (NodeData) iter.next();
            if (!usedFiles.contains(fileNodeData.getName()))
            {
                fileNodeData.delete();
            }
        }
        NodeDataUtil.getOrCreateAndSet(parentNode, name, new String(sbValue));
    }

}
